#ΥեGPLդƤޤ.
# connect2ch.rb  version 0.03
# ջ  haruyama@unixuser.org
# $Id: connect2ch.rb,v 1.4 2001/12/06 13:50:42 haruyama Exp $

# EUV
# ޤŬ

require 'kconv'
require 'net/http'
begin
  require 'zlib'
  $connect_2ch_gzip = true
rescue LoadError
  #
  $connect_2ch_gzip = false
end

module HTTPGetGzip


  def http_get_file(host,port,path,filename,gzip=true)
    
    http_header = {}
    if gzip
      gzip =  $connect_2ch_gzip
    end

    if gzip
      http_header["Accept-Encoding"]="gzip"
    end



    begin
      file = open( filename, 'w+' )
    rescue 
      STDERR.print "#{filename}ޤǤ\n"    
      return
    end
    begin
      Net::HTTP.start(host,port,$proxy_addr,$proxy_port){ |http|
	response , = http.get(path,http_header)
	file.write response.body
	file.rewind
	if  gzip == true && "gzip" == response['Content-Encoding']
	  begin 
	    file=Zlib::GzipReader.new(file)
	  rescue
	  end
	end
      }
    rescue 
      #      եμ˼
      return nil
    end
    return file
  end
end


module GetThread2ch
  include HTTPGetGzip

  def file_change(from,to)
    File.rename(from,to)
    file =  open(to,'r')
    begin
      file = Zlib::GzipReader.new(file)
    rescue
    end
    return file
  end

  def get_thread_file(thread,size=0,num_of_statements=0)
    host = thread.get_host
    port = thread.get_port
    path = thread.get_path
    filename = thread.get_filename
    file = thread.get_file    
    dat=  thread.get_dat
    return get_thread_file_(host,port,path,filename,file,dat,size,num_of_statements)
  end


  def get_thread_file_(host,port,path,filename,file,dat=nil,size=0,num_of_statements=0)

    if dat
      # datľɤ
      return get_thread_file_via_dat(host,port,path,filename)
    else
      return get_thread_file_via_read_cgi(host,port,path,filename,file,size,num_of_statements)
    end

  end

#̤ƥ
  def get_thread_file_via_dat(host,port,path,filename)
    
    file = http_get_file(host,port,path,filename)
    if file ==nil
      STDERR.print "datեμ˼Ԥޤ\n"
      return nil
    end
    return file
  end

  def get_thread_file_via_read_cgi(host,port,path,filename,file,size=0,num_of_statements=0)



    if file 
      file.rewind
    else
      if File.exist?(filename)
	file = open( filename, 'r' )
	begin
	  file = Zlib::GzipReader.new(file)
	rescue  
	  # gzipǤʤ
	end
      end
    end


    #ʬɤߤѽ ʬνϤʤꤤ

    if size <=0 && num_of_statements <=0
      size =0
      num_of_statements=0
      if file 
	file.each{ |line|
	  line=Kconv::kconv(line,Kconv::EUC,Kconv::SJIS)
	  if /^(?:\+OK|-INCR)\s+(\d+)/ =~ line
	    size+=Integer($1)
	  else
	    num_of_statements+=1
	  end
	}
      end

    end

    path += "?raw=#{num_of_statements}.#{size}"

    tmp_filename = filename+"_tmp"
    tmp_file = http_get_file(host,port,path,tmp_filename)

    if tmp_file ==nil
      STDERR.print "threadեμ˼Ԥޤ\n"
      return file
    end
    
    line= tmp_file.gets
    line=Kconv::kconv(line,Kconv::EUC,Kconv::SJIS)
    #TODO: 0ΤȤɲäʤ褦ˤ

    if /^\+OK\s+(\d+)/ =~ line
      if $1 == "0"
	tmp_file.close
	File.unlink(tmp_filename)
	return file
      end

      tmp_file.rewind
      if file 

	file.rewind
	contents = file.read
	file.close
	# fileʤ餺gzipǰ̤ƤȤϤʤΤ
	# ݤʤȤ򤹤
	# ޤ GzipReaderˤrewindϤäƤseekϤʤ
	# (gzipΥإå եåΤ)

	file = open(filename,'w')

	file = Zlib::GzipWriter.new(file)
	
	file.write  contents
	file.write  tmp_file.read
	
	file.close
	tmp_file.close

	File.unlink(tmp_filename)

	file =  open(filename,'r')
	file = Zlib::GzipReader.new(file)
      else
	tmp_file.close
	file = file_change(tmp_filename,filename)
      end
    elsif  /^\-INCR/ =~ line
      if file
	file.close
      end
      tmp_file.close

      file = file_change(tmp_filename,filename)
    else
      STDERR.print "threadե˰۾郎ޤ\n"
      tmp_file.close
      File.unlink(tmp_filename)
      return file
    end
    return file
  end


end

module  GetBoardSubject2ch
  include HTTPGetGzip


  def get_board_subject_file(board)
    host = board.get_host
    port = board.get_port
    path = board.get_path
    filename = board.get_filename
    return get_board_subject_file_(host,port,path,filename)
  end

  def get_board_subject_file_(host,port,path,filename)
    
    path2 = path + "subject.txt"
    file=http_get_file(host,port,path2,filename)

    if file == nil
      STDERR.print "subjectեμ˼Ԥޤ\n"
      return nil
    end

    return file

  end

end

#̤ƥ
module  GetBoardInfo2ch
  include HTTPGetGzip

  def get_board_info(host,port,path,filename)
    tmp_filename+= filename + "_tmp"

    tmp_file = http_get_file(host,port,path,tmp_filename)
    if tmp_file ==nil
      STDERR.print "board_infoեμ˼Ԥޤ\n"
      return nil
    end


    File.rename(filename,filename+"~")
    
    file = open(filename,'w+')
    tmp_file.rewind
    while line = tmp_file.gets
      while true
	line=Kconv::kconv(line,Kconv::EUC,Kconv::SJIS)
	if /^<B>(.*?)<\/B><BR>(.*)$/i =~  line
	  tmp ="C " + $1 +"\n"
	  if "å" == $1
	    throw :exit
	  elsif "ޤ££" == $1
	    flag=0
	  else
	    flag=1
	    file.print Kconv::kconv(tmp,Kconv::SJIS,Kconv::EUC)
	  end
	  line = $2
	elsif /^<A HREF=([^> ]*).*?>(.*?)<\/A>(.*)$/i =~ line
	  if $1 != "http://www.machibbs.com/"
	    if flag ==1
	      tmp = "B " 
	    elsif flag ==2
	      tmp = "A " 
	    end

	    if flag>0 
	      tmp += $1 + " " + $2  + "\n"
	      file.print Kconv::kconv(tmp,Kconv::SJIS,Kconv::EUC)
	    end
	  end
	  line = $3
	elsif /^.*?((<B>|<A).*)$/i =~ line
	  line = $1
	else
	  break
	end
      end
      
    end
    catch(:exit) do
    end
    
    tmp_file.close
    file.rewind
    return file
  end

end
